<template>
  <div class="wrapper">
    <div class="container">
      <md-table v-if="list" class="my-table">
        <md-table-row>
          <md-table-head md-numeric>Status</md-table-head>
          <md-table-head class="small">Name</md-table-head>
          <md-table-head class="md-small-hide">Description</md-table-head>
          <md-table-head class="md-small-hide">CreatedAt</md-table-head>
          <md-table-head>Options</md-table-head>
        </md-table-row>
        <md-table-row v-for="(el) in list" v-bind:item="el" v-bind:key="el._id">
          <md-table-cell>
            <md-button id="check-task-btn" class="md-fab md-primary md-mini" v-on:click="callParent('CHECK',el)">
              <md-icon v-if="el.completed">check_box</md-icon>
              <md-icon v-if="!el.completed">check_box_outline_blank</md-icon>
            </md-button>
          </md-table-cell>
          <md-table-cell>{{el.name}}</md-table-cell>
          <md-table-cell class="md-small-hide">{{el.description}}</md-table-cell>
          <md-table-cell class="md-small-hide">{{formatDate(el.createdAt)}}</md-table-cell>
          <md-table-cell>
            <div class="my-buttons">
              <md-button id="edit-task-btn" class="md-fab md-primary md-mini" v-on:click="callParent('EDIT',el)">
                <md-icon>edit</md-icon>
              </md-button>
              <md-button  id="delete-task-btn" class="md-fab md-mini" v-on:click="callParent('REMOVE',el)">
                <md-icon>delete</md-icon>
              </md-button>
            </div>
          </md-table-cell>
        </md-table-row>
      </md-table>
    </div>
  </div>
</template>

<script>
import moment from "moment";

export default {
  name: "TableComponent",
  props: {
    list: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  data() {
    return {};
  },

  methods: {
    callParent(type, { _id, name, description, CreatedAt, completed }) {
      this.$emit("interface", {
        _id,
        name,
        description,
        CreatedAt,
        completed,
        type
      });
    },
    formatDate(value) {
      return moment(value).format("YYYY-MM-DD HH:mm");
    }
  }
};
</script>

<style>

.wrapper {
  justify-content: center;
  display: flex;
}

.container {
  max-width: 800px;
  align-items: center;
}

.my-buttons {
  display: flex;
  flex-direction: row;
}
</style>
